<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: debug.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">debug.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="debug_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * PKCS #11 PAM Login Module</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Copyright (C) 2003 Mario Strasser &lt;mast@gmx.net&gt;,</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * This library is free software; you can redistribute it and/or</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * modify it under the terms of the GNU Lesser General Public</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * License as published by the Free Software Foundation; either</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * version 2.1 of the License, or (at your option) any later version.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * This library is distributed in the hope that it will be useful,</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * Lesser General Public License for more details.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> * $Id$</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#ifndef __DEBUG_H_</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#define __DEBUG_H_</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#ifdef HAVE_CONFIG_H</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;config.h&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#ifndef DEBUG</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#warning &quot;Debugging is completely disabled!&quot;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#define DBG</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define DBG1</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#define DBG2</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#define DBG3</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#define DBG4</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#define DBG5</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#define ERR</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#define ERR1</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="preprocessor">#define ERR2</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;<span class="preprocessor">#define ERR3</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#define ERR4</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#define ERR5</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="comment">#define DBG(f, ...) debug_print(1, __FILE__, __LINE__, f, ## __VA_ARGS__)</span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment">*/</span></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="comment">/* this syntax is redundant in GCC, just used to avoid warns in -pedantic */</span></div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="debug_8h.html#a7be8305523c50424eef047e1e3597c94">   54</a></span>&#160;<span class="preprocessor">#define DBG(f) debug_print(1, __FILE__, __LINE__, f )</span></div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="debug_8h.html#a58b20e2df4fbae54a5beceb08e4266fd">   55</a></span>&#160;<span class="preprocessor">#define DBG1(f,a) debug_print(1, __FILE__, __LINE__, f , a )</span></div><div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="debug_8h.html#ae63c856724c55362f47851412d680c19">   56</a></span>&#160;<span class="preprocessor">#define DBG2(f,a,b) debug_print(1, __FILE__, __LINE__, f , a , b )</span></div><div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="debug_8h.html#aa2468cf70eeeb3ac01eb626a280f6e13">   57</a></span>&#160;<span class="preprocessor">#define DBG3(f,a,b,c) debug_print(1, __FILE__, __LINE__, f , a , b , c )</span></div><div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="debug_8h.html#af27e0e60761d73fd6f4483f0e2710b8e">   58</a></span>&#160;<span class="preprocessor">#define DBG4(f,a,b,c,d) debug_print(1, __FILE__, __LINE__, f , a , b , c , d )</span></div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="debug_8h.html#a033ffe96e37806d43a871552bf6e9080">   59</a></span>&#160;<span class="preprocessor">#define DBG5(f,a,b,c,d,e) debug_print(1, __FILE__, __LINE__, f , a , b , c , d , e )</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="debug_8h.html#ab067bba050ad34a26a93f8d09ec37c1b">   61</a></span>&#160;<span class="preprocessor">#define ERR(f) debug_print(-1, __FILE__, __LINE__, f )</span></div><div class="line"><a name="l00062"></a><span class="lineno"><a class="line" href="debug_8h.html#a379142abff305e6614c25b2236b47ca5">   62</a></span>&#160;<span class="preprocessor">#define ERR1(f,a) debug_print(-1, __FILE__, __LINE__, f , a )</span></div><div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="debug_8h.html#af8fd1c2b8a0f4915dae665a28f3f179b">   63</a></span>&#160;<span class="preprocessor">#define ERR2(f,a,b) debug_print(-1, __FILE__, __LINE__, f , a , b )</span></div><div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="debug_8h.html#adeebf4c1aaabba0499ceaf255c5309a4">   64</a></span>&#160;<span class="preprocessor">#define ERR3(f,a,b,c) debug_print(-1, __FILE__, __LINE__, f , a , b , c )</span></div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="debug_8h.html#a2d7f1f356a5e28043b315662c10310e6">   65</a></span>&#160;<span class="preprocessor">#define ERR4(f,a,b,c,d) debug_print(-1, __FILE__, __LINE__, f , a , b , c , d )</span></div><div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="debug_8h.html#ab25ad5a5f0a5d5e7ee2672ee489a164d">   66</a></span>&#160;<span class="preprocessor">#define ERR5(f,a,b,c,d,e) debug_print(-1, __FILE__, __LINE__, f , a , b , c , d , e )</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="preprocessor">#ifndef __DEBUG_C_</span></div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="debug_8h.html#ac95c9471143c82c3e11f73b41e401559">   69</a></span>&#160;<span class="preprocessor">#define DEBUG_EXTERN extern</span></div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="preprocessor">#define DEBUG_EXTERN</span></div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<a class="code" href="debug_8h.html#ac95c9471143c82c3e11f73b41e401559">DEBUG_EXTERN</a> <span class="keywordtype">void</span> <a class="code" href="debug_8h.html#aa0bf418dd5c72aca6e7b0eb09a40e4c4">set_debug_level</a>(<span class="keywordtype">int</span> level);</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<a class="code" href="debug_8h.html#ac95c9471143c82c3e11f73b41e401559">DEBUG_EXTERN</a> <span class="keywordtype">int</span> <a class="code" href="debug_8h.html#a0a71da33384f6806f93542b4cb95d7d2">get_debug_level</a>(<span class="keywordtype">void</span>);</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;<a class="code" href="debug_8h.html#ac95c9471143c82c3e11f73b41e401559">DEBUG_EXTERN</a> <span class="keywordtype">void</span> <a class="code" href="debug_8h.html#a3539f46d66926ffee22314bf923ab57b">debug_print</a>(<span class="keywordtype">int</span> level, <span class="keyword">const</span> <span class="keywordtype">char</span> *file, <span class="keywordtype">int</span> line, <span class="keyword">const</span> <span class="keywordtype">char</span> *format, ...)</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="preprocessor">#if defined __GNUC__</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        __attribute__((format(printf, 4, 5)))</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        ;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="preprocessor">#undef DEBUG_EXTERN</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* DEBUG */</span><span class="preprocessor"></span></div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* __DEBUG_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="debug_8h_html_ac95c9471143c82c3e11f73b41e401559"><div class="ttname"><a href="debug_8h.html#ac95c9471143c82c3e11f73b41e401559">DEBUG_EXTERN</a></div><div class="ttdeci">#define DEBUG_EXTERN</div><div class="ttdef"><b>Definition:</b> <a href="debug_8h_source.html#l00069">debug.h:69</a></div></div>
<div class="ttc" id="debug_8h_html_a3539f46d66926ffee22314bf923ab57b"><div class="ttname"><a href="debug_8h.html#a3539f46d66926ffee22314bf923ab57b">debug_print</a></div><div class="ttdeci">DEBUG_EXTERN void debug_print(int level, const char *file, int line, const char *format,...)</div><div class="ttdoc">debug_print() prints the given message </div></div>
<div class="ttc" id="debug_8h_html_a0a71da33384f6806f93542b4cb95d7d2"><div class="ttname"><a href="debug_8h.html#a0a71da33384f6806f93542b4cb95d7d2">get_debug_level</a></div><div class="ttdeci">DEBUG_EXTERN int get_debug_level(void)</div><div class="ttdoc">get_debug_level() Returns the current debug level. </div></div>
<div class="ttc" id="debug_8h_html_aa0bf418dd5c72aca6e7b0eb09a40e4c4"><div class="ttname"><a href="debug_8h.html#aa0bf418dd5c72aca6e7b0eb09a40e4c4">set_debug_level</a></div><div class="ttdeci">DEBUG_EXTERN void set_debug_level(int level)</div><div class="ttdoc">set_debug_level() Sets the current debug level. </div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:34 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
